#include <iostream>
#include <cstdio>
#include <cstdlib>
// #define ASIO_USE_LIBAIO
#include "boost/asio.hpp"

void completion_handler(const boost::system::error_code& error, std::size_t bytes_transferred)
{
	std::cout << "completion handler called! error_code: " << error << "; bytes_transferred: " << bytes_transferred << std::endl;
}

char const * test_msg = "TEST";
char const * test_file_name = "test_file";

int main(void)
{
  boost::asio::io_service io_service;

  int const fd = ::open(test_file_name, O_CREAT | O_TRUNC | O_RDWR, S_IRUSR | S_IWUSR);
  if (fd < 0){
    perror("open()");
    abort();
  }
  boost::asio::stream_file file(io_service, fd);

  file.async_write(boost::asio::buffer(test_msg, strlen(test_msg) + 1), 0, completion_handler);

  io_service.run();

  char read_buf[5];
  file.async_read(boost::asio::buffer(read_buf, strlen(test_msg) + 1), 0, completion_handler);
  
  io_service.reset();
  io_service.run();

  std::cout << "message read from file: " << read_buf << std::endl;

  ::remove(test_file_name);
}
